diff --git a/target/linux/ipq806x/patches-3.18/011-watchdog-qcom-use-timer-devicetree-binding.patch b/target/linux/ipq806x/patches-3.18/011-watchdog-qcom-use-timer-devicetree-binding.patch
index 0cd7da1..68489a8 100644
--- a/target/linux/ipq806x/patches-3.18/011-watchdog-qcom-use-timer-devicetree-binding.patch
+++ b/target/linux/ipq806x/patches-3.18/011-watchdog-qcom-use-timer-devicetree-binding.patch
@@ -14,8 +14,6 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  drivers/watchdog/qcom-wdt.c | 21 +++++++++++++++------
  1 file changed, 15 insertions(+), 6 deletions(-)
 
-diff --git a/drivers/watchdog/qcom-wdt.c b/drivers/watchdog/qcom-wdt.c
-index aa85618..aa03ca8 100644
 --- a/drivers/watchdog/qcom-wdt.c
 +++ b/drivers/watchdog/qcom-wdt.c
 @@ -20,9 +20,9 @@
@@ -31,7 +29,7 @@ index aa85618..aa03ca8 100644
  
  struct qcom_wdt {
  	struct watchdog_device	wdd;
-@@ -117,6 +117,8 @@ static int qcom_wdt_probe(struct platform_device *pdev)
+@@ -117,6 +117,8 @@ static int qcom_wdt_probe(struct platfor
  {
  	struct qcom_wdt *wdt;
  	struct resource *res;
@@ -40,7 +38,7 @@ index aa85618..aa03ca8 100644
  	int ret;
  
  	wdt = devm_kzalloc(&pdev->dev, sizeof(*wdt), GFP_KERNEL);
-@@ -124,6 +126,14 @@ static int qcom_wdt_probe(struct platform_device *pdev)
+@@ -124,6 +126,14 @@ static int qcom_wdt_probe(struct platfor
  		return -ENOMEM;
  
  	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
@@ -55,7 +53,7 @@ index aa85618..aa03ca8 100644
  	wdt->base = devm_ioremap_resource(&pdev->dev, res);
  	if (IS_ERR(wdt->base))
  		return PTR_ERR(wdt->base);
-@@ -203,9 +213,8 @@ static int qcom_wdt_remove(struct platform_device *pdev)
+@@ -203,9 +213,8 @@ static int qcom_wdt_remove(struct platfo
  }
  
  static const struct of_device_id qcom_wdt_of_table[] = {
@@ -67,6 +65,3 @@ index aa85618..aa03ca8 100644
  	{ },
  };
  MODULE_DEVICE_TABLE(of, qcom_wdt_of_table);
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-3.18/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch b/target/linux/ipq806x/patches-3.18/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch
index 24a093a..ae96776 100644
--- a/target/linux/ipq806x/patches-3.18/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch
+++ b/target/linux/ipq806x/patches-3.18/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch
@@ -13,8 +13,6 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  arch/arm/boot/dts/qcom-ipq8064.dtsi | 14 +++++++++++++-
  1 file changed, 13 insertions(+), 1 deletion(-)
 
-diff --git a/arch/arm/boot/dts/qcom-ipq8064.dtsi b/arch/arm/boot/dts/qcom-ipq8064.dtsi
-index cb225da..d01f618 100644
 --- a/arch/arm/boot/dts/qcom-ipq8064.dtsi
 +++ b/arch/arm/boot/dts/qcom-ipq8064.dtsi
 @@ -60,6 +60,14 @@
@@ -48,6 +46,3 @@ index cb225da..d01f618 100644
  			cpu-offset = <0x80000>;
  		};
  
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-3.18/022-add-db149-dts.patch b/target/linux/ipq806x/patches-3.18/022-add-db149-dts.patch
index 9a036fb..85a0f72 100644
--- a/target/linux/ipq806x/patches-3.18/022-add-db149-dts.patch
+++ b/target/linux/ipq806x/patches-3.18/022-add-db149-dts.patch
@@ -13,8 +13,6 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  2 files changed, 258 insertions(+)
  create mode 100644 arch/arm/boot/dts/qcom-ipq8064-db149.dts
 
-diff --git a/arch/arm/boot/dts/Makefile b/arch/arm/boot/dts/Makefile
-index 38c89ca..745360a 100644
 --- a/arch/arm/boot/dts/Makefile
 +++ b/arch/arm/boot/dts/Makefile
 @@ -360,6 +360,7 @@ dtb-$(CONFIG_ARCH_QCOM) += \
@@ -25,9 +23,6 @@ index 38c89ca..745360a 100644
  	qcom-msm8660-surf.dtb \
  	qcom-msm8960-cdp.dtb \
  	qcom-msm8974-sony-xperia-honami.dtb
-diff --git a/arch/arm/boot/dts/qcom-ipq8064-db149.dts b/arch/arm/boot/dts/qcom-ipq8064-db149.dts
-new file mode 100644
-index 0000000..224c54f
 --- /dev/null
 +++ b/arch/arm/boot/dts/qcom-ipq8064-db149.dts
 @@ -0,0 +1,257 @@
@@ -288,6 +283,3 @@ index 0000000..224c54f
 +		};
 +	};
 +};
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-3.18/102-soc-qcom-gsbi-Add-support-for-ADM-CRCI-muxing.patch b/target/linux/ipq806x/patches-3.18/102-soc-qcom-gsbi-Add-support-for-ADM-CRCI-muxing.patch
index f37ebeb..752f3f7 100644
--- a/target/linux/ipq806x/patches-3.18/102-soc-qcom-gsbi-Add-support-for-ADM-CRCI-muxing.patch
+++ b/target/linux/ipq806x/patches-3.18/102-soc-qcom-gsbi-Add-support-for-ADM-CRCI-muxing.patch
@@ -1,8 +1,6 @@
-diff --git a/Documentation/devicetree/bindings/soc/qcom/qcom,gsbi.txt b/Documentation/devicetree/bindings/soc/qcom/qcom,gsbi.txt
-index 4ce24d4..186e5f4 100644
 --- a/Documentation/devicetree/bindings/soc/qcom/qcom,gsbi.txt
 +++ b/Documentation/devicetree/bindings/soc/qcom/qcom,gsbi.txt
-@@ -6,7 +6,8 @@ configuration settings.  The mode setting will govern the input/output mode of
+@@ -6,7 +6,8 @@ configuration settings.  The mode settin
  the 4 GSBI IOs.
  
  Required properties:
@@ -48,8 +46,6 @@ index 4ce24d4..186e5f4 100644
 +	};
 +
 +
-diff --git a/drivers/soc/qcom/Kconfig b/drivers/soc/qcom/Kconfig
-index 7bd2c94..460b2db 100644
 --- a/drivers/soc/qcom/Kconfig
 +++ b/drivers/soc/qcom/Kconfig
 @@ -4,6 +4,7 @@
@@ -60,8 +56,6 @@ index 7bd2c94..460b2db 100644
          help
            Say y here to enable GSBI support.  The GSBI provides control
            functions for connecting the underlying serial UART, SPI, and I2C
-diff --git a/drivers/soc/qcom/qcom_gsbi.c b/drivers/soc/qcom/qcom_gsbi.c
-index 729425d..09c669e 100644
 --- a/drivers/soc/qcom/qcom_gsbi.c
 +++ b/drivers/soc/qcom/qcom_gsbi.c
 @@ -18,22 +18,129 @@
@@ -194,7 +188,7 @@ index 729425d..09c669e 100644
  
  	gsbi = devm_kzalloc(&pdev->dev, sizeof(*gsbi), GFP_KERNEL);
  
-@@ -45,6 +152,32 @@ static int gsbi_probe(struct platform_device *pdev)
+@@ -45,6 +152,32 @@ static int gsbi_probe(struct platform_de
  	if (IS_ERR(base))
  		return PTR_ERR(base);
  
@@ -227,7 +221,7 @@ index 729425d..09c669e 100644
  	if (of_property_read_u32(node, "qcom,mode", &gsbi->mode)) {
  		dev_err(&pdev->dev, "missing mode configuration\n");
  		return -EINVAL;
-@@ -64,6 +197,25 @@ static int gsbi_probe(struct platform_device *pdev)
+@@ -64,6 +197,25 @@ static int gsbi_probe(struct platform_de
  	writel_relaxed((gsbi->mode << GSBI_PROTOCOL_SHIFT) | gsbi->crci,
  				base + GSBI_CTRL_REG);
  
@@ -253,6 +247,3 @@ index 729425d..09c669e 100644
  	/* make sure the gsbi control write is not reordered */
  	wmb();
  
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-3.18/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch b/target/linux/ipq806x/patches-3.18/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch
index 95398e0..41f91fa 100644
--- a/target/linux/ipq806x/patches-3.18/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch
+++ b/target/linux/ipq806x/patches-3.18/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch
@@ -27,9 +27,6 @@ Signed-off-by: Stanimir Varbanov <svarbanov@mm-sol.com>
  1 files changed, 231 insertions(+), 0 deletions(-)
  create mode 100644 Documentation/devicetree/bindings/pci/qcom,pcie.txt
 
-diff --git a/Documentation/devicetree/bindings/pci/qcom,pcie.txt b/Documentation/devicetree/bindings/pci/qcom,pcie.txt
-new file mode 100644
-index 0000000..dcf7348
 --- /dev/null
 +++ b/Documentation/devicetree/bindings/pci/qcom,pcie.txt
 @@ -0,0 +1,231 @@
diff --git a/target/linux/ipq806x/patches-3.18/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch b/target/linux/ipq806x/patches-3.18/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch
index 82170cd..cb740de 100644
--- a/target/linux/ipq806x/patches-3.18/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch
+++ b/target/linux/ipq806x/patches-3.18/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch
@@ -31,8 +31,6 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  3 files changed, 4 insertions(+), 1 deletion(-)
  create mode 100644 arch/arm/mach-qcom/Makefile.boot
 
-diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
-index 89c4b5c..4583ea5 100644
 --- a/arch/arm/Kconfig
 +++ b/arch/arm/Kconfig
 @@ -311,7 +311,7 @@ config ARCH_MULTIPLATFORM
@@ -44,11 +42,9 @@ index 89c4b5c..4583ea5 100644
  	select CLKSRC_OF
  	select COMMON_CLK
  	select GENERIC_CLOCKEVENTS
-diff --git a/arch/arm/Makefile b/arch/arm/Makefile
-index 7453352..5d6f8ac 100644
 --- a/arch/arm/Makefile
 +++ b/arch/arm/Makefile
-@@ -240,9 +240,11 @@ MACHINE  := arch/arm/mach-$(word 1,$(machine-y))/
+@@ -240,9 +240,11 @@ MACHINE  := arch/arm/mach-$(word 1,$(mac
  else
  MACHINE  :=
  endif
@@ -60,13 +56,7 @@ index 7453352..5d6f8ac 100644
  
  machdirs := $(patsubst %,arch/arm/mach-%/,$(machine-y))
  platdirs := $(patsubst %,arch/arm/plat-%/,$(sort $(plat-y)))
-diff --git a/arch/arm/mach-qcom/Makefile.boot b/arch/arm/mach-qcom/Makefile.boot
-new file mode 100644
-index 0000000..67a6d5a
 --- /dev/null
 +++ b/arch/arm/mach-qcom/Makefile.boot
 @@ -0,0 +1 @@
 +zreladdr-y+= 0x42208000
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-4.0/001-spi-qup-Add-DMA-capabilities.patch b/target/linux/ipq806x/patches-4.0/001-spi-qup-Add-DMA-capabilities.patch
index 62badd5..a500c67 100644
--- a/target/linux/ipq806x/patches-4.0/001-spi-qup-Add-DMA-capabilities.patch
+++ b/target/linux/ipq806x/patches-4.0/001-spi-qup-Add-DMA-capabilities.patch
@@ -330,7 +330,7 @@ Signed-off-by: Andy Gross <agross@codeaurora.org>
  	controller->error = error;
 @@ -339,6 +571,8 @@ static int spi_qup_io_config(struct spi_
  	struct spi_qup *controller = spi_master_get_devdata(spi->master);
- 	u32 config, iomode, mode;
+ 	u32 config, iomode, mode, control;
  	int ret, n_words, w_size;
 +	size_t dma_align = dma_get_cache_alignment();
 +	u32 dma_available = 0;
@@ -383,7 +383,7 @@ Signed-off-by: Andy Gross <agross@codeaurora.org>
  	iomode |= (mode << QUP_IO_M_OUTPUT_MODE_MASK_SHIFT);
  	iomode |= (mode << QUP_IO_M_INPUT_MODE_MASK_SHIFT);
  
-@@ -419,6 +670,14 @@ static int spi_qup_io_config(struct spi_
+@@ -428,6 +679,14 @@ static int spi_qup_io_config(struct spi_
  	config &= ~(QUP_CONFIG_NO_INPUT | QUP_CONFIG_NO_OUTPUT | QUP_CONFIG_N);
  	config |= xfer->bits_per_word - 1;
  	config |= QUP_CONFIG_SPI_MODE;
@@ -398,7 +398,7 @@ Signed-off-by: Andy Gross <agross@codeaurora.org>
  	writel_relaxed(config, controller->base + QUP_CONFIG);
  
  	/* only write to OPERATIONAL_MASK when register is present */
-@@ -452,25 +711,29 @@ static int spi_qup_transfer_one(struct s
+@@ -461,25 +720,29 @@ static int spi_qup_transfer_one(struct s
  	controller->tx_bytes = 0;
  	spin_unlock_irqrestore(&controller->lock, flags);
  
@@ -443,7 +443,7 @@ Signed-off-by: Andy Gross <agross@codeaurora.org>
  exit:
  	spi_qup_set_state(controller, QUP_STATE_RESET);
  	spin_lock_irqsave(&controller->lock, flags);
-@@ -553,6 +816,7 @@ static int spi_qup_probe(struct platform
+@@ -563,6 +826,7 @@ static int spi_qup_probe(struct platform
  	master->transfer_one = spi_qup_transfer_one;
  	master->dev.of_node = pdev->dev.of_node;
  	master->auto_runtime_pm = true;
@@ -451,7 +451,7 @@ Signed-off-by: Andy Gross <agross@codeaurora.org>
  
  	platform_set_drvdata(pdev, master);
  
-@@ -618,6 +882,56 @@ static int spi_qup_probe(struct platform
+@@ -628,6 +892,56 @@ static int spi_qup_probe(struct platform
  			QUP_ERROR_INPUT_UNDER_RUN | QUP_ERROR_OUTPUT_UNDER_RUN,
  			base + QUP_ERROR_FLAGS_EN);
  
@@ -508,7 +508,7 @@ Signed-off-by: Andy Gross <agross@codeaurora.org>
  	writel_relaxed(0, base + SPI_CONFIG);
  	writel_relaxed(SPI_IO_C_NO_TRI_STATE, base + SPI_IO_CONTROL);
  
-@@ -730,6 +1044,11 @@ static int spi_qup_remove(struct platfor
+@@ -740,6 +1054,11 @@ static int spi_qup_remove(struct platfor
  	if (ret)
  		return ret;
  
diff --git a/target/linux/ipq806x/patches-4.0/011-watchdog-qcom-use-timer-devicetree-binding.patch b/target/linux/ipq806x/patches-4.0/011-watchdog-qcom-use-timer-devicetree-binding.patch
index 0cd7da1..68489a8 100644
--- a/target/linux/ipq806x/patches-4.0/011-watchdog-qcom-use-timer-devicetree-binding.patch
+++ b/target/linux/ipq806x/patches-4.0/011-watchdog-qcom-use-timer-devicetree-binding.patch
@@ -14,8 +14,6 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  drivers/watchdog/qcom-wdt.c | 21 +++++++++++++++------
  1 file changed, 15 insertions(+), 6 deletions(-)
 
-diff --git a/drivers/watchdog/qcom-wdt.c b/drivers/watchdog/qcom-wdt.c
-index aa85618..aa03ca8 100644
 --- a/drivers/watchdog/qcom-wdt.c
 +++ b/drivers/watchdog/qcom-wdt.c
 @@ -20,9 +20,9 @@
@@ -31,7 +29,7 @@ index aa85618..aa03ca8 100644
  
  struct qcom_wdt {
  	struct watchdog_device	wdd;
-@@ -117,6 +117,8 @@ static int qcom_wdt_probe(struct platform_device *pdev)
+@@ -117,6 +117,8 @@ static int qcom_wdt_probe(struct platfor
  {
  	struct qcom_wdt *wdt;
  	struct resource *res;
@@ -40,7 +38,7 @@ index aa85618..aa03ca8 100644
  	int ret;
  
  	wdt = devm_kzalloc(&pdev->dev, sizeof(*wdt), GFP_KERNEL);
-@@ -124,6 +126,14 @@ static int qcom_wdt_probe(struct platform_device *pdev)
+@@ -124,6 +126,14 @@ static int qcom_wdt_probe(struct platfor
  		return -ENOMEM;
  
  	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
@@ -55,7 +53,7 @@ index aa85618..aa03ca8 100644
  	wdt->base = devm_ioremap_resource(&pdev->dev, res);
  	if (IS_ERR(wdt->base))
  		return PTR_ERR(wdt->base);
-@@ -203,9 +213,8 @@ static int qcom_wdt_remove(struct platform_device *pdev)
+@@ -203,9 +213,8 @@ static int qcom_wdt_remove(struct platfo
  }
  
  static const struct of_device_id qcom_wdt_of_table[] = {
@@ -67,6 +65,3 @@ index aa85618..aa03ca8 100644
  	{ },
  };
  MODULE_DEVICE_TABLE(of, qcom_wdt_of_table);
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-4.0/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch b/target/linux/ipq806x/patches-4.0/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch
index 24a093a..ae96776 100644
--- a/target/linux/ipq806x/patches-4.0/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch
+++ b/target/linux/ipq806x/patches-4.0/012-ARM-qcom-add-description-of-KPSS-WDT-for-IPQ8064.patch
@@ -13,8 +13,6 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  arch/arm/boot/dts/qcom-ipq8064.dtsi | 14 +++++++++++++-
  1 file changed, 13 insertions(+), 1 deletion(-)
 
-diff --git a/arch/arm/boot/dts/qcom-ipq8064.dtsi b/arch/arm/boot/dts/qcom-ipq8064.dtsi
-index cb225da..d01f618 100644
 --- a/arch/arm/boot/dts/qcom-ipq8064.dtsi
 +++ b/arch/arm/boot/dts/qcom-ipq8064.dtsi
 @@ -60,6 +60,14 @@
@@ -48,6 +46,3 @@ index cb225da..d01f618 100644
  			cpu-offset = <0x80000>;
  		};
  
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-4.0/022-add-db149-dts.patch b/target/linux/ipq806x/patches-4.0/022-add-db149-dts.patch
index 9a036fb..a274f24 100644
--- a/target/linux/ipq806x/patches-4.0/022-add-db149-dts.patch
+++ b/target/linux/ipq806x/patches-4.0/022-add-db149-dts.patch
@@ -13,11 +13,9 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  2 files changed, 258 insertions(+)
  create mode 100644 arch/arm/boot/dts/qcom-ipq8064-db149.dts
 
-diff --git a/arch/arm/boot/dts/Makefile b/arch/arm/boot/dts/Makefile
-index 38c89ca..745360a 100644
 --- a/arch/arm/boot/dts/Makefile
 +++ b/arch/arm/boot/dts/Makefile
-@@ -360,6 +360,7 @@ dtb-$(CONFIG_ARCH_QCOM) += \
+@@ -438,6 +438,7 @@ dtb-$(CONFIG_ARCH_QCOM) += \
  	qcom-apq8084-ifc6540.dtb \
  	qcom-apq8084-mtp.dtb \
  	qcom-ipq8064-ap148.dtb \
@@ -25,9 +23,6 @@ index 38c89ca..745360a 100644
  	qcom-msm8660-surf.dtb \
  	qcom-msm8960-cdp.dtb \
  	qcom-msm8974-sony-xperia-honami.dtb
-diff --git a/arch/arm/boot/dts/qcom-ipq8064-db149.dts b/arch/arm/boot/dts/qcom-ipq8064-db149.dts
-new file mode 100644
-index 0000000..224c54f
 --- /dev/null
 +++ b/arch/arm/boot/dts/qcom-ipq8064-db149.dts
 @@ -0,0 +1,257 @@
@@ -288,6 +283,3 @@ index 0000000..224c54f
 +		};
 +	};
 +};
--- 
-1.9.1
-
diff --git a/target/linux/ipq806x/patches-4.0/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch b/target/linux/ipq806x/patches-4.0/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch
index 95398e0..41f91fa 100644
--- a/target/linux/ipq806x/patches-4.0/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch
+++ b/target/linux/ipq806x/patches-4.0/110-DT-PCI-qcom-Document-PCIe-devicetree-bindings.patch
@@ -27,9 +27,6 @@ Signed-off-by: Stanimir Varbanov <svarbanov@mm-sol.com>
  1 files changed, 231 insertions(+), 0 deletions(-)
  create mode 100644 Documentation/devicetree/bindings/pci/qcom,pcie.txt
 
-diff --git a/Documentation/devicetree/bindings/pci/qcom,pcie.txt b/Documentation/devicetree/bindings/pci/qcom,pcie.txt
-new file mode 100644
-index 0000000..dcf7348
 --- /dev/null
 +++ b/Documentation/devicetree/bindings/pci/qcom,pcie.txt
 @@ -0,0 +1,231 @@
diff --git a/target/linux/ipq806x/patches-4.0/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch b/target/linux/ipq806x/patches-4.0/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch
index 82170cd..930a463 100644
--- a/target/linux/ipq806x/patches-4.0/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch
+++ b/target/linux/ipq806x/patches-4.0/300-arch-arm-force-ZRELADDR-on-arch-qcom.patch
@@ -31,11 +31,9 @@ Signed-off-by: Mathieu Olivari <mathieu@codeaurora.org>
  3 files changed, 4 insertions(+), 1 deletion(-)
  create mode 100644 arch/arm/mach-qcom/Makefile.boot
 
-diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
-index 89c4b5c..4583ea5 100644
 --- a/arch/arm/Kconfig
 +++ b/arch/arm/Kconfig
-@@ -311,7 +311,7 @@ config ARCH_MULTIPLATFORM
+@@ -314,7 +314,7 @@ config ARCH_MULTIPLATFORM
  	select ARCH_WANT_OPTIONAL_GPIOLIB
  	select ARM_HAS_SG_CHAIN
  	select ARM_PATCH_PHYS_VIRT
@@ -44,11 +42,9 @@ index 89c4b5c..4583ea5 100644
  	select CLKSRC_OF
  	select COMMON_CLK
  	select GENERIC_CLOCKEVENTS
-diff --git a/arch/arm/Makefile b/arch/arm/Makefile
-index 7453352..5d6f8ac 100644
 --- a/arch/arm/Makefile
 +++ b/arch/arm/Makefile
-@@ -240,9 +240,11 @@ MACHINE  := arch/arm/mach-$(word 1,$(machine-y))/
+@@ -241,9 +241,11 @@ MACHINE  := arch/arm/mach-$(word 1,$(mac
  else
  MACHINE  :=
  endif
@@ -60,13 +56,7 @@ index 7453352..5d6f8ac 100644
  
  machdirs := $(patsubst %,arch/arm/mach-%/,$(machine-y))
  platdirs := $(patsubst %,arch/arm/plat-%/,$(sort $(plat-y)))
-diff --git a/arch/arm/mach-qcom/Makefile.boot b/arch/arm/mach-qcom/Makefile.boot
-new file mode 100644
-index 0000000..67a6d5a
 --- /dev/null
 +++ b/arch/arm/mach-qcom/Makefile.boot
 @@ -0,0 +1 @@
 +zreladdr-y+= 0x42208000
--- 
-1.9.1
-